#include <stdio.h>
#include <windows.h>
#include "ibm.h"

int nvrmask=63;
unsigned char nvrram[128];
int nvraddr;

SYSTEMTIME systemtime;

void getnvrtime()
{
        int c,d;
        unsigned char baknvr[10];
        memcpy(baknvr,nvrram,10);
        GetLocalTime(&systemtime);
        d=systemtime.wSecond%10;
        c=systemtime.wSecond/10;
        nvrram[0]=d|(c<<4);
        d=systemtime.wMinute%10;
        c=systemtime.wMinute/10;
        nvrram[2]=d|(c<<4);
        d=systemtime.wHour%10;
        c=systemtime.wHour/10;
        nvrram[4]=d|(c<<4);
        d=systemtime.wDayOfWeek%10;
        c=systemtime.wDayOfWeek/10;
        nvrram[6]=d|(c<<4);
        d=systemtime.wDay%10;
        c=systemtime.wDay/10;
        nvrram[7]=d|(c<<4);
        d=systemtime.wMonth%10;
        c=systemtime.wMonth/10;
        nvrram[8]=d|(c<<4);
        d=systemtime.wYear%10;
        c=systemtime.wYear/10;
        nvrram[9]=d|(c<<4);
        if (baknvr[0]!=nvrram[0] ||
            baknvr[2]!=nvrram[2] ||
            baknvr[4]!=nvrram[4] ||
            baknvr[6]!=nvrram[6] ||
            baknvr[7]!=nvrram[7] ||
            baknvr[8]!=nvrram[8] ||
            baknvr[9]!=nvrram[9]) nvrram[0xA]|=0x80;
}

void writenvr(unsigned short addr, unsigned char val)
{
//        printf("Write NVR %03X %02X %02X %04X:%04X\n",addr,nvraddr,val,cs>>4,pc);
        if (addr&1) nvrram[nvraddr]=val;
        else        nvraddr=val&nvrmask;
}

unsigned char readnvr(unsigned short addr)
{
        unsigned char temp;
//        printf("Read NVR %03X %02X %02X %04X:%04X\n",addr,nvraddr,nvrram[nvraddr],cs>>4,pc);
        if (addr&1)
        {
                if (nvraddr<=0xA) getnvrtime();
                if (nvraddr==0xD) nvrram[0xD]|=0x80;
                if (nvraddr==0xA)
                {
                        temp=nvrram[0xA];
                        nvrram[0xA]&=~0x80;
                        return temp;
                }
//                if (AMIBIOS && nvraddr==0x36) return 0;
//                if (nvraddr==0xA) nvrram[0xA]^=0x80;
                return nvrram[nvraddr];
        }
        return nvraddr;
}

void loadnvr()
{
        FILE *f;
        nvrmask=63;
        switch (romset)
        {
                case ROM_EUROPC:   loadeuropc(); return; /*Euro PC uses a different NVR system*/
                case ROM_PC1512:   f=romfopen("pc1512.nvr","rb"); break;
                case ROM_PC1640:   f=romfopen("pc1640.nvr","rb"); break;
                case ROM_IBMAT:    f=romfopen("at.nvr"    ,"rb"); break;
                case ROM_AMI286:   f=romfopen("ami286.nvr","rb"); nvrmask=127; break;
                case ROM_IBMAT386: f=romfopen("at386.nvr"    ,"rb"); nvrmask=127; break;
                case ROM_AMI386:   f=romfopen("ami386.nvr","rb"); nvrmask=127; break;
                case ROM_AMI486:   f=romfopen("ami486.nvr","rb"); nvrmask=127; break;
                default: return;
        }
        if (!f)
        {
                memset(nvrram,0xFF,128);
                return;
        }
        fread(nvrram,128,1,f);
        fclose(f);
}
void savenvr()
{
        FILE *f;
        switch (romset)
        {
                case ROM_EUROPC:   saveeuropc(); return;
                case ROM_PC1512:   f=romfopen("pc1512.nvr","wb"); break;
                case ROM_PC1640:   f=romfopen("pc1640.nvr","wb"); break;
                case ROM_IBMAT:    f=romfopen("at.nvr"    ,"wb"); break;
                case ROM_AMI286:   f=romfopen("ami286.nvr","wb"); break;
                case ROM_IBMAT386: f=romfopen("at386.nvr"    ,"wb"); break;
                case ROM_AMI386:   f=romfopen("ami386.nvr"    ,"wb"); break;
                case ROM_AMI486:   f=romfopen("ami486.nvr"    ,"wb"); break;
                default: return;
        }
        fwrite(nvrram,128,1,f);
        fclose(f);
}
